---
stages:
  - gen-spec
  - auto-commit

variables:
  REPO: terraform-docs/terraform-docs
  SPEC_FILENAME: terraform-docs.spec
  SCRIPT_PATH: https://gitlab.com/mapanare-labs/mapanarelabs/scripts/-/raw/main/upgrade-spec.sh

image:
  name: alpine/git:v2.47.1
  entrypoint: [""]

# rules:
#   - if: "$CI_COMMIT_BRANCH =~ /^(feature\\/)/"
#   - if: "$CI_COMMIT_BRANCH =~ /^(bugfix\\/)/"
#   - if: "$CI_COMMIT_BRANCH =~ /^(hotfix\\/)/"
#   - if: "$CI_COMMIT_BRANCH =~ /^(renovate\\/)/"
#   - when: never

gen-spec:
  stage: gen-spec
  before_script:
    - apk add --no-cache bash curl
  script:
    - echo "Generating the spec file."
    - curl -o upgrade-spec.sh $SCRIPT_PATH
    - chmod +x upgrade-spec.sh && bash ./upgrade-spec.sh
  artifacts:
    paths:
      - ./$SPEC_FILENAME
    expire_in: 1 day
  allow_failure: true

auto-commit:
  stage: auto-commit
  before_script:
    - git config --global user.email "$GIT_EMAIL"
    - git config --global user.name "$GIT_USER"
  script:
    #- git checkout $CI_COMMIT_REF_NAME
    - git status
    - git add $SPEC_FILENAME || true # To ensure no error is thrown if there are no changes to commit.
    - git commit -m "[spec] Updating Version" || true # To ensure no error is thrown if there are no changes to commit.
    - git push -f https://$GITLAB_USER_LOGIN:$API_TOKEN@$CI_SERVER_HOST/$CI_PROJECT_PATH.git HEAD:$CI_COMMIT_REF_NAME || true
    - echo "Commit successful"
  allow_failure: true
